## acl2 6.4

=== projects/milawa/ACL2/Makefile ===
# Milawa Makefile
# Copyright (C) 2005-2009 by Jared Davis <jared@cs.utexas.edu>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.  You should have received a copy of the GNU General Public
# License along with this program (see the file COPYING); if not, write to the
# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.

all:

STARTJOB ?= $(SHELL)
PWD := $(shell pwd)

PATH := $(PWD)/acl2-images:$(PATH)
WAIT := $(PWD)/wait.pl

# We really only need to tell cert.pl about the high level books we care about.
# This is a little haphazard, but basically we don't want to include the
# bootstrap/ dir or use some find command since it might be slow.
FILES_FOR_CERTPL := \
  levels/*.lisp rewrite/*.lisp interface/*.lisp \
  tactics/*.lisp clauses/*.lisp build/*.lisp

FILES_FOR_PCERTSCAN := \
  bootstrap/utilities/top \
  bootstrap/logic/top \
  bootstrap/level2/level2 \
  bootstrap/level3/level3 \
  bootstrap/level4/level4 \
  bootstrap/level5/level5 \
  bootstrap/level6/level6 \
  bootstrap/level7/level7 \
  bootstrap/level8/level8 \
  bootstrap/level9/level9 \
  bootstrap/level10/level10 \
  bootstrap/level11/level11 \
  bootstrap/user/multiply

$(info Calculating cert dependencies...)
DO_CERT_DEPS := $(shell ../../../build/cert.pl $(FILES_FOR_CERTPL) \
           --quiet \
           --static-makefile Makefile-deps \
           --var-prefix BOOKS_TOP \
           --cache Makefile-cache \
	   --bin `pwd`/acl2-images)
$(info Calculating pcert dependencies...)
DO_PCERT_DEPS := $(shell ./pcert-scan.pl $(FILES_FOR_PCERTSCAN) &> Makefile-pdeps)
$(info Done with dependencies.)
include Makefile-deps
include Makefile-pdeps


# I renamed .pcert files to .mpcert after ACL2 added provisional certification
# support.
%.mpcert: %.lisp
	@echo "Making $*.mpcert"
	@$(STARTJOB) -c "./pcert.pl $*.lisp &> $*.out"
	@$(WAIT) $*.mpcert
	@ls -l $*.mpcert


.PHONY: all clean

# We could use cert.pl to clean up the certs, but it misses a few because of
# images; this once led me to be pretty confused because an old cert was being
# inappropriately included, leading to a strange error.  So I think it's better
# to just aggressively remove certs here.
clean:
	@echo "Cleaning ACL2 directory (certificates, ACL2 images, etc.)"
	@../../../build/clean.pl
	@rm -f `find . -name "*.mpcert"`
	@rm -f `find . -name "*.out"`
	@rm -f `find . -name "*.time"`
	@rm -f `find . -name "*.port"`
	@rm -f `find . -name "*.lx64fsl"`
	@rm -f `find . -name "*.ccl"`
	@rm -f `find . -name "*.proof"`
	@rm -f `find . -name ".acl2rc"`
	@rm -f acl2-images/*-acl2 acl2-images/*-symmetry
	@rm -f acl2-images/*-acl2.* acl2-images/*-symmetry.*
	@rm -f Makefile-deps Makefile-cache
	@rm -f logic/autodoc/*.tex
	@rm -f build/autodoc/*.tex
	@rm -f rewrite/assms/autodoc/*.tex
	@rm -f rewrite/traces/autodoc/*.tex
	@rm -f rewrite/autodoc/*.tex
	@rm -f clauses/autodoc/*.tex
	@rm -f clauses/if-lifting/autodoc/*.tex
	@rm -f classic/autodoc/*.tex
	@rm -f tactics/autodoc/*.tex
	@rm -f bootstrap/*/autodoc/*.tex
	@rm -f Makefile-cache Makefile-deps Makefile-pdeps TAGS
	@echo "Cleaning ../Proofs directory."
	@cd ../Proofs; ./clean-proofs.sh

acl2-images/tactics-acl2: rewrite/fast-crewrite-clause.cert \
                  rewrite/traces/trace-arities.cert \
                  rewrite/theory-arities.cert \
                  rewrite/urewrite-clause.cert \
                  clauses/split-bldr.cert \
                  clauses/compiler.cert \
                  clauses/disjoined-update-clause-bldr.cert \
                  rewrite/gather.cert
	@echo "Making $@"
	@cd tactics; $(STARTJOB) -c \
	  "$(ACL2) < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/interface-acl2: acl2-images/tactics-acl2 \
	                    levels/level11.cert
	@echo "Making $@"
	@cd interface; $(STARTJOB) -c \
	  "../acl2-images/tactics-acl2 < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*


acl2-images/utilities-symmetry: acl2-images/interface-acl2 \
	                        interface/top.cert
	@echo "Making $@"
	@cd bootstrap/utilities; $(STARTJOB) -c \
	   "../../acl2-images/interface-acl2 < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/logic-symmetry: acl2-images/utilities-symmetry \
                            $(PCDEPS_FOR_bootstrap__utilities__top)
	@echo "Making $@"
	@cd bootstrap/logic; $(STARTJOB) -c \
	   "../../acl2-images/utilities-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/level2-symmetry: acl2-images/logic-symmetry \
                             $(PCDEPS_FOR_bootstrap__logic__top)
	@echo "Making $@"
	@cd bootstrap/level2; $(STARTJOB) -c \
	  "../../acl2-images/logic-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/level3-symmetry: acl2-images/level2-symmetry \
                           $(PCDEPS_FOR_bootstrap__level2__level2)
	@echo "Making $@"
	@cd bootstrap/level3; $(STARTJOB) -c \
	  "../../acl2-images/level2-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/level4-symmetry: acl2-images/level3-symmetry \
                           $(PCDEPS_FOR_bootstrap__level3__level3)
	@echo "Making $@"
	@cd bootstrap/level4; $(STARTJOB) -c \
	  "../../acl2-images/level3-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/level5-symmetry: acl2-images/level4-symmetry \
                           $(PCDEPS_FOR_bootstrap__level4__level4)
	@echo "Making $@"
	@cd bootstrap/level5; $(STARTJOB) -c \
	  "../../acl2-images/level4-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/level6-symmetry: acl2-images/level5-symmetry \
                           $(PCDEPS_FOR_bootstrap__level5__level5)
	@echo "Making $@"
	@cd bootstrap/level6; $(STARTJOB) -c \
	  "../../acl2-images/level5-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/level7-symmetry: acl2-images/level6-symmetry \
                           $(PCDEPS_FOR_bootstrap__level6__level6)
	@echo "Making $@"
	@cd bootstrap/level7; $(STARTJOB) -c \
	  "../../acl2-images/level6-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/level8-symmetry: acl2-images/level7-symmetry \
                           $(PCDEPS_FOR_bootstrap__level7__level7)
	@echo "Making $@"
	@cd bootstrap/level8; $(STARTJOB) -c \
	  "../../acl2-images/level7-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/level9-symmetry: acl2-images/level8-symmetry \
                           $(PCDEPS_FOR_bootstrap__level8__level8)
	@echo "Making $@"
	@cd bootstrap/level9; $(STARTJOB) -c \
	  "../../acl2-images/level8-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/level10-symmetry: acl2-images/level9-symmetry \
                            $(PCDEPS_FOR_bootstrap__level9__level9)
	@echo "Making $@"
	@cd bootstrap/level10; $(STARTJOB) -c \
	  "../../acl2-images/level9-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/level11-symmetry: acl2-images/level10-symmetry \
                            $(PCDEPS_FOR_bootstrap__level10__level10)
	@echo "Making $@"
	@cd bootstrap/level11; $(STARTJOB) -c \
	  "../../acl2-images/level10-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

acl2-images/user-symmetry: acl2-images/level11-symmetry \
                         $(PCDEPS_FOR_bootstrap__level11__level11)
	@echo "Making $@"
	@cd bootstrap/user; $(STARTJOB) -c \
	  "../../acl2-images/level11-symmetry < make-image.lsp &> make-image.out"
	@$(WAIT) "$@"
	@ls -l "$@"*

all: acl2-images/user-symmetry

all: $(ALL_PCERTS)


TAGS: $(BOOKS_TOP_SOURCES)
	@echo "Making $@"
	@etags $(BOOKS_TOP_SOURCES)

=== centaur/esim/stv/stv2c/Makefile ===
# ESIM Symbolic Hardware Simulator
# Copyright (C) 2010-2013 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http:#www.centtech.com/
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.  You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.

.PHONY: all clean
all:

ifndef STV_GCC_DIR
$(error STV_GCC_DIR environment variable is required, but not set. \
        Please set STV_GCC_DIR to point at the installation of GCC \
        to use, or edit the Makefile to suit your system.)
endif

STARTJOB  ?= bash
CXX       := $(STV_GCC_DIR)/bin/g++
CXXFLAGS  := -Wall -std=gnu++11 -g -O3
LINKFLAGS := -L$(STV_GCC_DIR)/lib64 -Wl,-rpath,$(STV_GCC_DIR)/lib64

all: test_bits alu16

%.o: %.cc
	$(CXX) -c $(CXXFLAGS) $<

test_bits: test_bits.o
	$(CXX) $(CXXFLAGS) $(LINKFLAGS) test_bits.o -o test_bits


# ALU16 Tutorial Example.  For this command to work, you'll have to build the
# VL toolkit and add it to your path (see acl2/books/Makefile)

alu16_test.cc: alu16_test.stv ../../../tutorial/alu16.v
	$(STARTJOB) -c \
	  "vl stv2c --stv alu16_test.stv ../../../tutorial/alu16.v &> alu16_test.out"

alu16_test.o: alu16_test.cc fourval.h bits.h


# C++ test bench for the generated ALU16 code.

alu16: alu16_test.o alu16.cc
	$(CXX) $(CXXFLAGS) $(LINKFLAGS) alu16.cc alu16_test.o -o alu16


# I won't delete the cert files, because you can just run clean.pl if you
# really want to do that.

clean:
	rm -f test_bits test_bits.o
	rm -f alu16 alu16_test.h alu16_test.cc alu16_test.out

=== debian/changelog ===
acl2 (6.4-4) unstable; urgency=low

  * parse and use parallel keyword in DEB_BUILD_OPTIONS

 -- Camm Maguire <camm@debian.org>  Thu, 15 May 2014 18:49:32 +0000

acl2 (6.4-3) unstable; urgency=low

  * set HOME in rule to build saved_acl2.c
  * Bug fix: "not buildable on buildds on some architectures", thanks to
    Ivo De Decker (Closes: #747286).

 -- Camm Maguire <camm@debian.org>  Fri, 09 May 2014 15:38:15 +0000

acl2 (6.4-2) unstable; urgency=low

  * certify-books run with -j 8 -l 2.95
  * Bug fix: "Process running beyond build (missing escape in
    debian/rules)", thanks to Michael Tautschnig (Closes: #746203).
  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 07 May 2014 18:31:48 +0000

acl2 (6.4-1) unstable; urgency=low

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Mon, 13 Jan 2014 16:14:44 +0000

acl2 (6.3-6) unstable; urgency=low

  * rebuild against latest gcl

 -- Camm Maguire <camm@debian.org>  Fri, 15 Nov 2013 16:11:57 +0000

=== debian/control ===
Source: acl2
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: gcl ( >= 2.6.10-10 ), libgmp3-dev, libreadline-dev, emacs24 | emacsen, debhelper ( >= 5 ), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common, texinfo
Standards-Version: 3.9.4

Package: acl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: acl2-source, acl2-books
Suggests: acl2-emacs
Description: Computational Logic for Applicative Common Lisp: main binary
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the base ACL2 binary. 

Package: acl2-source
Architecture: all
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Depends: ${misc:Depends}	  
Description: Computational Logic for Applicative Common Lisp: source files
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the lisp source files to the main ACL2 binary.

Package: acl2-emacs
Architecture: all
Depends: acl2 (>= ${source:Version}), emacs24 | emacsen, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: emacs interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains an emacs interface to ACL2.

Package: acl2-infix
Architecture: any
Recommends: acl2-infix-source (= ${source:Version})
Depends: acl2 (= ${binary:Version}), texlive-latex-recommended, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains utilities and libraries to access ACL2 via an
 infix notation similar to that used in many non-lisp programming
 languages.

Package: acl2-infix-source
Architecture: all
Depends: ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix source
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the source files to the infix interface to
 ACL2.

Package: acl2-books
Architecture: any
Depends: acl2 (= ${binary:Version}), acl2-books-certs (= ${source:Version}), acl2-books-source (= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: compiled libraries
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains numerous precompiled and precertified libraries
 for use in proving theorems with ACL2.  Serious users will no doubt
 want to install this package.

Package: acl2-books-source
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library sources
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains source lisp files to the compiled libraries
 supplied in the ACL2-books package.

Package: acl2-books-certs
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library certificates
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This file contains certification records for the various precompiled
 libraries supplied in the ACL2-books package.  ACL2 essentially
 requires that all included books be certified before use.

Package: acl2-doc
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Architecture: all
Section: doc
Description: Computational Logic for Applicative Common Lisp: documentation
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the documentation for ACL2.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=4

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=acl2
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)


NO_STRIP:=
# ifeq ($(DEB_BUILD_ARCH),powerpc)
# NO_STRIP:=--exclude=saved_acl2
# endif

NUMJOBS:=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS:=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
NUMJOBS:=$(shell if test $(NUMJOBS) -gt 8; then echo 8 ; else echo $(NUMJOBS); fi)

books/workshops:
	mkdir $@

#init.lsp.ori: 
#	[ -e $@ ] || mv init.lsp $@

DLOPEN_T:=debian/dlopen.lisp #init.lsp.ori 

#ifeq ($(DEB_BUILD_ARCH),ia64)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),alpha)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mips)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mipsel)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),hppa)
#DLOPEN?=$(DLOPEN_T)
#endif

debian/dlopen.lisp: debian/dlopen.lisp.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

debian/acl2-emacs.emacsen-startup: debian/acl2-emacs.emacsen-startup.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

saved_acl2: $(DLOPEN_T) #debian/patches_applied 
#	echo '(progn (load "debian/sublis_patch.lsp")(si::save-system "pgcl"))' | gcl
	gcl -batch -eval "(bye #-native-reloc 1)" || \
		(gcl -batch -eval '(load "debian/dlopen.lisp")' && $(MAKE) do_saved)
	gcl -batch -eval "(bye #+native-reloc 1)" || $(MAKE) LISP=gcl
	mv *$@.gcl $@

saved_acl2.c: saved_acl2
	echo "(f-put-global 'old-certification-dir \"$$(pwd)/books\" state)" \
              "(f-put-global 'new-certification-dir \"/usr/share/$(PD)/books\" state)" \
	      ":q #-native-reloc (setq si::*multiply-stacks* 4) :q (in-package :acl2) " \
	      "#+(or sparc sparc64)(progn (si::sgc-on nil) (fmakunbound 'si::sgc-on))" \
              "(save-exec \"$@\" \"Modified to produce final certification files\")" | HOME=$$(pwd) ./$<
	mv $@.gcl $@

debian/mini-proveall.out: saved_acl2
	HOME=$$(pwd) $(MAKE) mini-proveall
	mv $(@F) $@

books/short-test.log: saved_acl2.c
	cp saved_acl2 saved_acl2.ori
	HOME=$$(pwd) $(MAKE) certify-books-short
	cp saved_acl2.ori saved_acl2

#	tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \

debian/test.log: saved_acl2.c
	mv saved_acl2 saved_acl2.ori
	cp $< saved_acl2
	BUILDDIR="$$(dirname $$(pwd))" \
	FINALDIR="/usr/share/$(PD)" \
	HOME=$$(pwd) \
	$(MAKE) -j $(NUMJOBS) certify-books 2>&1 | tee $@
#	$(MAKE) -j 8 -l 2.95 certify-books >$@ 2>&1 & j=$$! ; \
#	while sleep 1800; do echo Tick; done & k=$$! ; tail -f debian/test.log & l=$$! ; \
#	wait $$j ; kill $$k $$l
	[ -f $@ ] && ! fgrep '**' $@ || (echo FULL TEST FAILS ;\
		for i in $$(find books -name "*.out"); do \
			if ! [ -e $${i%out}cert ] ; then \
				echo $$i ; \
				cat $$i ; \
			fi ; \
		done)
	mv saved_acl2.ori saved_acl2
	[ -f $@ ] && ( ! fgrep '**' $@ || \
	  gcl -batch -eval "(bye #+native-reloc 1)" || \
	  [ $$(ulimit -d -H | sed 's,unlimited,1000000,g') -lt 1000000 ] )

books/interface/infix/Makefile: books/interface/infix/makefile
	sed -e "s,^DIR = .*,DIR = $$(pwd)/books/interface/infix,1" \
	    -e "s,^LISP = .*,LISP = $$(pwd)/saved_acl2,1" $< > $@

infix-stamp: books/interface/infix/Makefile saved_acl2
	cd books/interface/infix && make -f Makefile compile 
	cd books/interface/infix && make -f Makefile example 
#	cd books/interface/infix && make -f Makefile events 
	touch $@

doc/TEX/acl2-book.ps.gz: saved_acl2
	HOME=$$(pwd) $(MAKE) DOC
	rm -f doc/HTML/LICENSE
	find doc -empty -exec rm {} \;

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: debian/mini-proveall.out debian/test.log infix-stamp # doc/TEX/acl2-book.ps.gz
	dh_testdir

#	$(MAKE)

	touch build-stamp

infix_clean: books/interface/infix/Makefile
	rm -f infix-stamp 
	cd books/interface/infix && make -f Makefile clean
	rm -f books/interface/infix/Makefile


debian/dpatches: debian/patches.in
	debian/rules debian/patches_unapplied
	cat $< | sed -e "s,@BDIR@,$$(pwd),1" -e "s,@DDIR@,/usr/share/$(PD),1" >$@

debian/patches_applied: debian/dpatches
	! [ -e debian/patches_unapplied ] || \
		(patch -p1 < $< && rm -f debian/patches_unapplied)
	touch $@

debian/patches_unapplied: 
	! [ -e debian/patches_applied ] || ! [ -e debian/dpatches ] ||  \
		(patch -p1 -R < debian/dpatches && rm -f debian/patches_applied)
	touch $@


INSTALLS:=$(addprefix debian/,$(addsuffix .install,acl2 acl2-source acl2-emacs acl2-doc acl2-books acl2-books-source acl2-books-certs acl2-infix acl2-infix-source))
LINKS:=$(addprefix debian/,$(addsuffix .links,acl2 acl2-books acl2-infix))
IFILES:=$(INSTALLS) $(shell ls -1 debian/*.examples debian/*.docs)
debian/README.Debian: debian/README.Debian.in $(IFILES)
	awk '/@PLIST@/ {exit 0} {print}' $< >$@
	for i in $(filter %.install,$^); do\
	 awk '/^debian\// {next} {sub(".final$$","",$$1);$$2="/" $$2;print $$0 " " p}' \
		p=$$(basename $${i%.install}) $$i >>$@ ; done
	for i in $(filter %.info,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/info " p}' p=$$(basename $${i%.info}) $$i >>$@ ; done
	for i in $(filter %.examples,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p "/examples " p}' \
		p=$$(basename $${i%.examples}) $$i >>$@ ; done
	for i in $(filter %.docs,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p " " p}' p=$$(basename $${i%.docs}) $$i >>$@ ; done
	awk '/@PLIST@/ {i=1;next} {if (i) print}' $< >>$@

clean: books/workshops infix_clean #debian/patches_unapplied
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	$(MAKE) clean
	$(MAKE) clean-books
	find books -name "*.final" -exec rm {} \;
	rm -f saved_acl2 init_nsaved1_acl2.lsp worklispext
	rm -f debian/mini-proveall.out books/short-test.log debian/test.log
#	! [ -e init.lsp.ori ] || mv init.lsp.ori init.lsp
	rm -f foo.lsp nsaved_acl2
	for i in data c h ; do \
		for j in $$(find -name "*.$$i") ; do\
			k=$$(echo $$j | sed "s,\.$$i$$,,1") ;\
			! [ -e $$k.lisp ] || rm $$j ; \
		done ; \
	done
	rm -f books/bdd/benchmarks.data acl2r.lisp tmp
	rmdir $<
	rm -f debian/dpatches $(INSTALLS) $(LINKS) debian/README.Debian saved_acl2*
	rm -f debian/dlopen.lisp debian/acl2-emacs.emacsen-startup
	rm -f debian/acl2.sh pgcl books/Makefile-tmp books/coi/gensym/gensym.out
	rm -f books/coi/gensym/Makefile-deps books/coi/gensym/workxxx.gensym
	rm -rf doc/HTML-old doc/EMACS-old doc/acl2-wc.txt
	rm -f books/centaur/bitops/bitsets-opt-raw.o books/centaur/vl/util/gc-raw.o \
		books/centaur/misc/tshell-raw.o books/centaur/vl/Makefile-tmp
	dh_clean -XTAGS

debian/acl2-infix.install:: 
	find books/interface/infix -name "*.o" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@
	find books/interface/infix -name "*.sty" | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/texmf/tex/latex\n",$$1);}' >>$@

debian/acl2-infix-source.install:: 
	find books/interface/infix -name "*.lisp" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-emacs.install:: 
	find books/interface/emacs -name "*.el" | awk '{printf("%s usr/share/emacs/site-lisp/$(PN)\n",$$1);}' >>$@
	find emacs -name "*.el" | awk '{printf("%s usr/share/emacs/site-lisp/$(PN)\n",$$1);}' >>$@

debian/acl2.install:: 
	echo debian/acl2.sh usr/bin >>$@
	echo saved_acl2 usr/lib/$(PD) >>$@

debian/acl2-books.install:: 
	find books -name "*.o" | grep -v interface/ | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-source.install:: 
	find * -name "*.lisp" -maxdepth 0 | grep -v TMP1.lisp | awk '{printf("%s usr/share/$(PD)\n",$$1);}' >$@

## acl2 6.5

=== coi/Makefile ===
DIRS =	symbol-fns \
	util \
	adviser \
	nary \
	lists \
	osets \
	syntax \
	bags \
	alists \
	records \
	records/fast \
	paths \
	maps \
	dtrees \
	defpun \
	defstructure \
	super-ihs \
	gacc \
	gensym \
        generalize \
	quantification \
	termination \
	defung

include ../Makefile-subdirs

=== demos/Makefile ===
all: top

DIRS = modeling tutorial-problems

include ../Makefile-subdirs
include ../Makefile-generic
-include Makefile-deps

=== hacking/Makefile ===
# Nullify chk-include-book-worlds target (see Makefile-generic):
ACL2_SKIP_CHK_INCLUDE_BOOK_WORLDS = t

include ../Makefile-generic
-include Makefile-deps

# Note: Because of Lisp-specific readtime conditionals in
# evalable-ld-printing.lisp (e.g., search for `gcl'), "make o" and
# such using one host Lisp may report uncertified books when
# certification was done with an ACL2 based on a different host Lisp.
# This seems like a reasonably harmless state of affairs, however.
# We do prevent failed attempts to compile for multiple Lisps, as
# follows:

BOOKS_SKIP_COMP := evalable-ld-printing

=== rtl/Makefile ===
DIRS = rel1 rel4 rel5 rel9

# Note: Directories rel2 and rel3 still exist, but are no longer
# distributed.  Directory rel1 is needed not only for ACL2(r) but also
# for a few workshop books (e.g. 1999/embedded/Proof-Of-Contribution/
# and 2000/russinoff-kaufmann/supporting-materials/).  Hanbing Liu
# pointed out that rel7 is very similar to rel6, so we no longer
# distribute or even test with rel6.  Also rel8 seems somewhat similar
# to rel7, so we no longer certify books in rel7 by default, though we
# may still distribute it.  And finally, note that rel8/lib and
# rel9/support/lib3/ are essentially the same; so we now skip rel8.

# Note that file ../Makefile-psubdirs is engineered to skip gracefully
# over any missing subdirectories.

include ../Makefile-psubdirs

=== coi/defung/Makefile ===
include ../../Makefile-generic
BOOKS = ack-variants map-ec-call phony-induction split defung defung-test monadic rev3
-include Makefile-deps

=== demos/tutorial-problems/Makefile ===
new-top: top all
all: top

DIRS = equivalence-of-two-functions

include ../../Makefile-subdirs
include ../../Makefile-generic
-include Makefile-deps

=== projects/symbolic/Makefile ===
DIRS = tiny-fib m5 generic tiny-triangle
include ../../Makefile-subdirs

=== xdoc/fancy/Makefile ===
# This is an extremely stupid hack for converting render.xsl into a form that
# can be easily loaded into JavaScript.  There's probably a much better way to
# do this.

render.js : render.xsl
	echo "var xslt_base64 = \"" > render.tmp
	base64 < render.xsl >> render.tmp
	echo "\";" >> render.tmp
	tr -d '\n' < render.tmp > render.js
	rm render.tmp
	ls -la render.js

# We don't need to convert render-html.xsl, because we don't need it
# in javascript format.

=== centaur/vl/systest/Makefile ===
# VL Verilog Toolkit
# Copyright (C) 2008-2014 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http://www.centtech.com/
#
# License: (An MIT/X11-style license)
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.
#
# Original author: Jared Davis <jared@centtech.com>

.PHONY: all clean debug

ACL2     ?= acl2

VERILOG    ?= ncverilog +access+r
SYSVERILOG ?= ncverilog +access+r +sv +define+SYSTEM_VERILOG_MODE

STARTJOB ?= bash
VL       ?= $(PWD)/../bin/vl

SPEC_FILES    := $(wildcard */spec.v)
TEST_DIRS     := $(patsubst %/spec.v, %,               $(SPEC_FILES))
V_IMPL_FILES  := $(patsubst %/spec.v, %/impl.v,        $(SPEC_FILES))
SV_IMPL_FILES := $(patsubst %/spec.v, %/impl.sv,       $(SPEC_FILES))
V_OKS         := $(patsubst %/spec.v, %/verilog.ok,    $(SPEC_FILES))
SV_OKS        := $(patsubst %/spec.v, %/sysverilog.ok, $(SPEC_FILES))

all:

debug:
	@echo "PWD is $(PWD)"
	@echo "SPEC_FILES = $(SPEC_FILES)"
	@echo "TEST_DIRS = $(TEST_DIRS)"
	@echo "IMPL_FILES = $(IMPL_FILES)"


TRANSLATE_V  := $(VL) model spec.v --mem=2 --search=. --verilog-file=impl.v  --edition=Verilog
TRANSLATE_SV := $(VL) model spec.v --mem=2 --search=. --verilog-file=impl.sv --edition=SystemVerilog --define=SYSTEM_VERILOG_MODE

%/impl.sv: %/spec.v
	@echo "Making $*/impl.sv"
	@cd $*; $(STARTJOB) -c \
	  'echo `hostname` &> impl.out; $(TRANSLATE_SV) &>> impl.sv.out'
	@ls -l $*/impl.sv

%/impl.v: %/spec.v
	@echo "Making $*/impl.v"
	@cd $*; $(STARTJOB) -c \
	  'echo `hostname` &> impl.out; $(TRANSLATE_V) &>> impl.out'
	@ls -l $*/impl.v

%/verilog.ok: %/impl.v $(wildcard %/*.v)
	@echo "Making $*/verilog.ok"
	@cd $*; $(STARTJOB) -c "$(VERILOG) compare.v &> verilog.out"
	@ls -l $*/verilog.out
	@./errcheck.pl $*/verilog.out
# Dumb, need some kind of certificate here
	@cp $*/verilog.out $*/verilog.ok

%/sysverilog.ok: %/impl.sv $(wildcard %/*.v)
	@echo "Making $*/sysverilog.ok"
	@cd $*; $(STARTJOB) -c "$(SYSVERILOG) compare.v &> sysverilog.out"
	@ls -l $*/sysverilog.out
	@./errcheck.pl $*/sysverilog.out
# Dumb, need some kind of certificate here
	@cp $*/sysverilog.out $*/sysverilog.ok

clean:
	rm -f */impl.v */impl.sv */*.sao */*.log */*.out */*.ok
	rm -rf */INCA_libs */*.vcd */*.key

all: $(V_IMPL_FILES)
all: $(SV_IMPL_FILES)
all: $(V_OKS)
all: $(SV_OKS)

=== nonstd/workshops/2011/Makefile ===
# This is the workshops/2011/ Makefile under books/nonstd.

DIRS = reid-gamboa-differentiator/support
include ../../Makefile-subdirs

tar: clean
	@for dir in $(DIRS) ; \
	do \
	tar cvf $$dir.tar $$dir ; \
	done

=== nonstd/workshops/2013/Makefile ===
# This is the workshops/2013/ Makefile under books/nonstd.

DIRS = helms-gamboa-quantum/support
include ../../Makefile-subdirs

=== projects/symbolic/generic/Makefile ===
include ../../../Makefile-generic
-include Makefile-deps

# The generic theorems:

# partial-correctness
# total-correctness
# assertions.cert
# measures.cert
# defsimulate

# The demos:

# tiny-fib-correct
# factorial-jvm-correct

=== debian/changelog ===
acl2 (6.5-2~bpo70+1) wheezy-backports; urgency=medium

  * Backport to wheezy

 -- Camm Maguire <camm@debian.org>  Tue, 13 Jan 2015 10:12:27 -0500

acl2 (6.5-2) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 20 Aug 2014 00:37:33 +0000

acl2 (6.5-1) unstable; urgency=low

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Tue, 05 Aug 2014 16:04:06 +0000

acl2 (6.4-5) unstable; urgency=low

  * rebuild against latest gcl
  * lintian cleanups

 -- Camm Maguire <camm@debian.org>  Fri, 25 Jul 2014 15:25:39 +0000

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: math
 Priority: optional
 Maintainer: Camm Maguire <camm@debian.org>
-Build-Depends: gcl ( >= 2.6.10-10 ), libgmp3-dev, libreadline-dev, emacs24 | emacsen, debhelper ( >= 5 ), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common, texinfo
-Standards-Version: 3.9.4
+Build-Depends: gcl ( >= 2.6.7 ), libgmp3-dev, libreadline-dev, emacs24 | emacsen, debhelper ( >= 5 ), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common, texinfo
+Standards-Version: 3.9.5
 
 Package: acl2
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -106,8 +106,7 @@
 		done)
 	mv saved_acl2.ori saved_acl2
 	[ -f $@ ] && ( ! fgrep '**' $@ || \
-	  gcl -batch -eval "(bye #+native-reloc 1)" || \
-	  [ $$(ulimit -d -H | sed 's,unlimited,1000000,g') -lt 1000000 ] )
+	  gcl -batch -eval "(bye #-native-reloc 0 #+native-reloc (let ((w (multiple-value-bind (a b c d) (si::heap-report) (/ (- d c) (/ a 8))))) (format t \"certification run with ~s heap words~%\" w) (if (< w 500000000) 0 1)))")
 
 books/interface/infix/Makefile: books/interface/infix/makefile
 	sed -e "s,^DIR = .*,DIR = $$(pwd)/books/interface/infix,1" \
@@ -198,7 +197,8 @@
 	rm -f books/coi/gensym/Makefile-deps books/coi/gensym/workxxx.gensym
 	rm -rf doc/HTML-old doc/EMACS-old doc/acl2-wc.txt
 	rm -f books/centaur/bitops/bitsets-opt-raw.o books/centaur/vl/util/gc-raw.o \
-		books/centaur/misc/tshell-raw.o books/centaur/vl/Makefile-tmp
+		books/centaur/misc/tshell-raw.o books/centaur/vl/Makefile-tmp \
+		books/build/Makefile-sources books/build/Makefile-certs 
 	dh_clean -XTAGS
 
 debian/acl2-infix.install:: 
@@ -218,7 +218,3 @@
 	echo saved_acl2 usr/lib/$(PD) >>$@
 
 debian/acl2-books.install:: 
-	find books -name "*.o" | grep -v interface/ | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@
-
-debian/acl2-source.install:: 
-	find * -name "*.lisp" -maxdepth 0 | grep -v TMP1.lisp | awk '{printf("%s usr/share/$(PD)\n",$$1);}' >$@
